part of tecfy_core_client_package;

class PropertyColor extends Property {
  
  bool defaultValue;

  PropertyColor.fromMap(Map row) : super.fromMap(row);

  @override
  OperationResult isValid(data) {    
    if (!super.isValid(data).success) return super.isValid(data);
    
    return OperationResult(success: true);
  }
  
  Widget getDisplayWidget(Map data,{double size = 12, Color color= Colors.black}){
    return Container(width:20,height:20, color: HexColor(data[dbName] ));
  }

  Future<bool> getDefaultValue(Map<String,dynamic> data)async{
   if(data[dbName] != null) return false;
   if(defaultString.isNotEmpty) {
     data[dbName] = (defaultString.toLowerCase() == "true");
     return true;
   }else
   if(isRequired){
    data[dbName] =false;
    return true;
   }
   return false;
  }
}

class HexColor extends Color {
  static int _getColorFromHex(String hexColor) {
    hexColor = hexColor.toUpperCase().replaceAll("#", "");
    if (hexColor.length == 6) {
      hexColor = "FF" + hexColor;
    }
    return int.parse(hexColor, radix: 16);
  }

  HexColor(final String hexColor) : super(_getColorFromHex(hexColor));
}