part of tecfy_core_client_package;

class PropertyManyToMany extends Property {
  String middleEntityName;
  String middlePropertyName;
  String middleOtherPropertyName;
  String entityName;

  /// <summary>
  /// When value is true, the type should be List<ManyToManyTableName>
  /// but when it's false the type should be List<int>
  /// </summary>
  bool isWithData;

  bool isFilter;

  /// <summary>
  /// where value of FilterField is null of embty then the value of FilterValueField must refer to Array proerty of same dropdwn Entity
  /// </summary>
  String filterField;

  /// <summary>
  /// where value of FilterField is null of embty then the value of FilterValueField must refer to Array proerty of same dropdwn Entity
  /// </summary>
  String filterValueField;

  PropertyManyToMany.fromMap(Map row) : super.fromMap(row) {
    middleEntityName = lowerFirst(row['middleEntityName']);
    middlePropertyName = lowerFirst(row['middlePropertyName']);
    middleOtherPropertyName = lowerFirst(row['middleOtherPropertyName']);
    entityName = lowerFirst(row['entityName']);
    isWithData = row['isWithData'];

    isFilter = row['isFilter'];
    filterField = lowerFirst(row['filterField']);
    filterValueField = lowerFirst(row['filterValueField']);
  }
  @override
  OperationResult isValid(data) {    
    if (!super.isValid(data).success) return super.isValid(data);
    
    return OperationResult(success: true);
  }

  Widget getDisplayWidget(Map data,{double size = 12, Color color= Colors.black}){
    return Text('ManyToMany');
  }

Future<bool> getDefaultValue(Map<String,dynamic> data)async{
   if(data[dbName] != null) return false;
   
   return false;
  }
}
